# Copyright (c) 2000-2009, JPackage Project
# https://github.com/fedora-java/javapackages/blob/master/LICENSE

%global jtuid       110
%global username    %{name}
%global confdir     %{_sysconfdir}/%{name}
%global logdir      %{_localstatedir}/log/%{name}
%global homedir     %{_datadir}/%{name}
%global jettycachedir %{_localstatedir}/cache/%{name}
%global tempdir     %{jettycachedir}/temp
%global rundir      %{_localstatedir}/run/%{name}
%global jettylibdir %{_localstatedir}/lib/%{name}
%global appdir      %{jettylibdir}/webapps
%global addver  .v20210413

%bcond_without  jp_minimal

Summary:        Java Webserver and Servlet Container
Name:           jetty
Version:        9.4.40
Release: 4%{?dist}
License:        ASL 2.0 or EPL-1.0
URL:            http://www.eclipse.org/jetty/
Source0:        https://github.com/eclipse/%{name}.project/archive/%{name}-%{version}%{addver}.tar.gz
Source1:        jetty.sh
Source2:        jetty.logrotate
Source3:        %{name}.service
Source4:        LICENSE-MIT

Patch3000:      0001-Distro-jetty.home.patch
Patch3001:      0002-Port-to-servlet-api-4-5.patch
Patch3002:	0003-Fix-CVE-2023-36479.patch
# Patch3003:	0004-Fix-CVE-2023-41900.patch
Patch3004:	0005-Fix-CVE-2023-40167.patch

%if %{without jp_minimal}
BuildRequires: glassfish-el systemd junit5 jboss-websocket-1.0-api
BuildRequires: mvn(org.eclipse.jetty.toolchain:jetty-distribution-remote-resources) mvn(org.eclipse.jetty.toolchain:jetty-test-policy) maven-javadoc-plugin
BuildRequires: mvn(org.ow2.asm:asm-commons) mvn(org.slf4j:slf4j-api) mvn(org.mortbay.jetty.alpn:alpn-boot) mvn(org.eclipse.jetty.toolchain:jetty-artifact-remote-resources)
BuildRequires: mvn(org.eclipse.jetty.toolchain:jetty-test-helper) mvn(org.jboss.weld.servlet:weld-servlet-core) mvn(org.mongodb:mongo-java-driver) mvn(org.ow2.asm:asm)
BuildRequires: mvn(org.eclipse.jetty.orbit:javax.mail.glassfish) mvn(org.eclipse.jetty.orbit:javax.security.auth.message) mvn(org.eclipse.jetty.toolchain:jetty-assembly-descriptors) mvn(org.eclipse.jetty.toolchain:jetty-schemas)
BuildRequires: mvn(org.apache.tomcat:tomcat-jasper) mvn(org.codehaus.mojo:build-helper-maven-plugin) mvn(org.codehaus.mojo:exec-maven-plugin) mvn(org.eclipse.jetty.alpn:alpn-api)
BuildRequires: mvn(org.apache.maven.plugin-tools:maven-plugin-tools-api) mvn(org.apache.maven.shared:maven-artifact-transfer) mvn(org.apache.taglibs:taglibs-standard-impl) mvn(org.apache.taglibs:taglibs-standard-spec)
BuildRequires: mvn(org.apache.maven.plugins:maven-remote-resources-plugin) mvn(org.apache.maven.plugins:maven-shade-plugin) mvn(org.apache.maven.plugins:maven-war-plugin) mvn(org.apache.maven.plugin-tools:maven-plugin-annotations)
BuildRequires: mvn(org.apache.maven.plugins:maven-assembly-plugin) mvn(org.apache.maven.plugins:maven-dependency-plugin) mvn(org.apache.maven.plugins:maven-failsafe-plugin) mvn(org.apache.maven.plugins:maven-plugin-plugin)
BuildRequires: mvn(org.apache.maven:maven-core) mvn(org.apache.maven:maven-plugin-api) mvn(org.apache.maven:maven-project) mvn(org.apache.maven.plugins:maven-antrun-plugin)
BuildRequires: mvn(org.apache.ant:ant) mvn(org.apache.ant:ant-launcher) mvn(org.apache.felix:maven-bundle-plugin) mvn(org.apache.maven:maven-artifact)
BuildRequires: mvn(javax.servlet:jstl) mvn(javax.transaction:javax.transaction-api) mvn(javax.websocket:javax.websocket-api) mvn(javax.websocket:javax.websocket-client-api)
BuildRequires: mvn(javax.annotation:javax.annotation-api) mvn(javax.enterprise:cdi-api) mvn(javax.servlet:javax.servlet-api) mvn(javax.servlet.jsp:javax.servlet.jsp-api)
BuildRequires: maven-local mvn(com.github.jnr:jnr-unixsocket)
Requires:       jboss-websocket-1.0-api
%endif
BuildRequires: mvn(org.codehaus.mojo:build-helper-maven-plugin) mvn(org.slf4j:slf4j-api) mvn(org.apache.maven.plugins:maven-shade-plugin) jdependency
BuildRequires: maven-local mvn(javax.servlet:javax.servlet-api) mvn(org.apache.felix:maven-bundle-plugin) mvn(org.apache.maven.plugins:maven-shade-plugin)

BuildArch:      noarch
ExclusiveArch:  %{java_arches} noarch

%if %{without jp_minimal}
Requires: javapackages-tools
Requires: %{name}-http2-http-client-transport = %{version}-%{release} %{name}-http2-server = %{version}-%{release}
Requires: %{name}-http2-common = %{version}-%{release} %{name}-http2-hpack = %{version}-%{release}
Requires: %{name}-alpn-server = %{version}-%{release} %{name}-http2-client = %{version}-%{release}
Requires: %{name}-jstl = %{version}-%{release} %{name}-alpn-client = %{version}-%{release}
Requires: %{name}-nosql = %{version}-%{release} %{name}-quickstart = %{version}-%{release}
Requires: %{name}-javax-websocket-client-impl = %{version}-%{release} %{name}-javax-websocket-server-impl = %{version}-%{release}
Requires: %{name}-websocket-server = %{version}-%{release} %{name}-websocket-servlet = %{version}-%{release}
Requires: %{name}-websocket-client = %{version}-%{release} %{name}-websocket-common = %{version}-%{release}
Requires: %{name}-cdi = %{version}-%{release} %{name}-websocket-api = %{version}-%{release}
Requires: %{name}-webapp = %{version}-%{release} %{name}-xml = %{version}-%{release}
Requires: %{name}-util = %{version}-%{release} %{name}-util-ajax = %{version}-%{release}
Requires: %{name}-start = %{version}-%{release} %{name}-unixsocket = %{version}-%{release}
Requires: %{name}-servlet = %{version}-%{release} %{name}-servlets = %{version}-%{release}
Requires: %{name}-security = %{version}-%{release} %{name}-server = %{version}-%{release}
Requires: %{name}-proxy = %{version}-%{release} %{name}-rewrite = %{version}-%{release}
Requires: %{name}-maven-plugin = %{version}-%{release} %{name}-plus = %{version}-%{release}
Requires: %{name}-jsp = %{version}-%{release} %{name}-jspc-maven-plugin = %{version}-%{release}
Requires: %{name}-jmx = %{version}-%{release} %{name}-jndi = %{version}-%{release}
Requires: %{name}-jaas = %{version}-%{release} %{name}-jaspi = %{version}-%{release}
Requires: %{name}-http-spi = %{version}-%{release} %{name}-io = %{version}-%{release}
Requires: %{name}-fcgi-server = %{version}-%{release} %{name}-http = %{version}-%{release}
Requires: %{name}-deploy = %{version}-%{release} %{name}-fcgi-client = %{version}-%{release}
Requires: %{name}-client = %{version}-%{release} %{name}-continuation = %{version}-%{release}
Requires: %{name}-annotations = %{version}-%{release} %{name}-ant = %{version}-%{release}
Requires(pre):    shadow-utils
%{?systemd_ordering}

Provides:       group(%username) = %jtuid
Provides:       user(%username)  = %jtuid
%endif


%description
Jetty is a 100% Java HTTP Server and Servlet Container. This means that you\
do not need to configure and run a separate web server (like Apache) in order\
to use Java, servlets and JSPs to generate dynamic content. Jetty is a fully\
featured web server for static and dynamic content. Unlike separate\
server/container solutions, this means that your web server and web\
application run in the same process, without interconnection overheads\
and complications. Furthermore, as a pure java component, Jetty can be simply\
included in your application for demonstration, distribution or deployment.\
Jetty is available on all Java supported platforms.

%package        client
Summary:        client module for Jetty

%description    client
%{summary}.

%package        continuation
Summary:        continuation module for Jetty

%description    continuation
%{summary}.

%package        http
Summary:        http module for Jetty

%description    http
%{summary}.

%package        http-spi
Summary:        http-spi module for Jetty

%description    http-spi
%{summary}.

%package        io
Summary:        io module for Jetty

%description    io
%{summary}.

%package        jaas
Summary:        jaas module for Jetty

%description    jaas
%{summary}.

%package        jsp
Summary:        jsp module for Jetty
Requires:       glassfish-el

%description    jsp
%{summary}.

%package        security
Summary:        security module for Jetty

%description    security
%{summary}.

%package        server
Summary:        server module for Jetty

%description    server
%{summary}.

%package        servlet
Summary:        servlet module for Jetty

%description    servlet
%{summary}.

%package        util
Summary:        util module for Jetty
License:        (ASL 2.0 or EPL-1.0) and MIT

%description    util
%{summary}.

%package        util-ajax
Summary:        util-ajax module for Jetty

%description    util-ajax
%{summary}.

%package        webapp
Summary:        webapp module for Jetty

%description    webapp
%{summary}.

%package        jmx
Summary:        jmx module for Jetty

%description    jmx
%{summary}.

%package        xml
Summary:        xml module for Jetty

%description    xml
%{summary}.



%if %{without jp_minimal}
%package        project
Summary:        POM files for Jetty
Provides:       %{name}-websocket-parent = %{version}-%{release}
Provides:       %{name}-osgi-project = %{version}-%{release}

%description    project
%{summary}.

%package        deploy
Summary:        deploy module for Jetty

%description    deploy
%{summary}.

%package        annotations
Summary:        annotations module for Jetty

%description    annotations
%{summary}.

%package        ant
Summary:        ant module for Jetty

%description    ant
%{summary}.

%package cdi
Summary:        Jetty CDI Configuration

%description cdi
%{summary}.

%package        fcgi-client
Summary:        FastCGI client module for Jetty

%description    fcgi-client
%{summary}.

%package        fcgi-server
Summary:        FastCGI client module for Jetty

%description    fcgi-server
%{summary}.

%package        jaspi
Summary:        jaspi module for Jetty

%description    jaspi
%{summary}.

%package        jndi
Summary:        jndi module for Jetty

%description    jndi
%{summary}.

%package        jspc-maven-plugin
Summary:        jspc-maven-plugin module for Jetty

%description    jspc-maven-plugin
%{summary}.

%package        maven-plugin
Summary:        maven-plugin module for Jetty

%description    maven-plugin
%{summary}.

%package        plus
Summary:        plus module for Jetty

%description    plus
%{summary}.

%package        proxy
Summary:        proxy module for Jetty

%description    proxy
%{summary}.

%package        rewrite
Summary:        rewrite module for Jetty

%description    rewrite
%{summary}.

%package        servlets
Summary:        servlets module for Jetty

%description    servlets
%{summary}.

%package        start
Summary:        start module for Jetty

%description    start
%{summary}.

%package        unixsocket
Summary:        unixsocket module for Jetty

%description    unixsocket
%{summary}.

%package        websocket-api
Summary:        websocket-api module for Jetty

%description    websocket-api
%{summary}.

%package        websocket-client
Summary:        websocket-client module for Jetty

%description    websocket-client
%{summary}.

%package        websocket-common
Summary:        websocket-common module for Jetty

%description    websocket-common
%{summary}.

%package        websocket-server
Summary:        websocket-server module for Jetty

%description    websocket-server
%{summary}.

%package        websocket-servlet
Summary:        websocket-servlet module for Jetty

%description    websocket-servlet
%{summary}.

%package        javax-websocket-client-impl
Summary:        javax-websocket-client-impl module for Jetty

%description    javax-websocket-client-impl
%{summary}.

%package        javax-websocket-server-impl
Summary:        javax-websocket-server-impl module for Jetty

%description    javax-websocket-server-impl
%{summary}.

%package        nosql
Summary:        nosql module for Jetty

%description    nosql
%{summary}.

%package        quickstart
Summary:        quickstart module for Jetty

%description    quickstart
%{summary}.

%package        alpn-client
Summary:        alpn-client module for Jetty

%description    alpn-client
%{summary}.

%package        alpn-server
Summary:        alpn-server module for Jetty

%description    alpn-server
%{summary}.

%package        http2-client
Summary:        http2-client module for Jetty

%description    http2-client
%{summary}.

%package        http2-common
Summary:        http2-common module for Jetty

%description    http2-common
%{summary}.

%package        http2-hpack
Summary:        http2-hpack module for Jetty

%description    http2-hpack
%{summary}.

%package        http2-http-client-transport
Summary:        http2-http-client-transport module for Jetty

%description    http2-http-client-transport
%{summary}.

%package        http2-server
Summary:        http2-server module for Jetty

%description    http2-server
%{summary}.

%package        jstl
Summary:        jstl module for Jetty

%description    jstl
%{summary}.

%endif

%package        javadoc
Summary:        Javadoc for %{name}
License:        (ASL 2.0 or EPL-1.0) and MIT

%description    javadoc
%{summary}.

%prep
%autosetup -p1 -n %{name}.project-%{name}-%{version}%{addver}


find . -name "*.?ar" -exec rm {} \;
find . -name "*.class" -exec rm {} \;

%pom_remove_plugin -r :maven-checkstyle-plugin
%pom_remove_plugin -r :spotbugs-maven-plugin
%pom_remove_plugin -r :maven-enforcer-plugin
%pom_remove_plugin -r :maven-eclipse-plugin
%pom_remove_plugin -r :license-maven-plugin
%pom_remove_plugin -r :maven-site-plugin
%pom_remove_plugin -r :maven-source-plugin
%pom_remove_plugin -r :maven-deploy-plugin
%pom_remove_plugin -r :jacoco-maven-plugin
%pom_remove_plugin -r :maven-release-plugin
%pom_remove_plugin -r :buildnumber-maven-plugin
%pom_remove_plugin -r :h2spec-maven-plugin
%pom_remove_plugin -r :flatten-maven-plugin jetty-bom

%pom_disable_module aggregates/jetty-all

%pom_xpath_inject "pom:configuration/pom:instructions" \
"<Import-Package>sun.misc;resolution:=optional,com.sun.nio.file;resolution:=optional,*</Import-Package>"

%pom_remove_dep "com.sun.net.httpserver:http" jetty-http-spi

%pom_change_dep -r org.mortbay.jasper:apache-jsp org.apache.tomcat:tomcat-jasper

%pom_add_dep 'org.junit.jupiter:junit-jupiter-engine:${junit.version}' tests/test-sessions/test-sessions-common
%pom_change_dep -r javax.servlet.jsp:jsp-api javax.servlet.jsp:javax.servlet.jsp-api
%pom_remove_plugin ":jetty-version-maven-plugin"
%pom_xpath_remove "pom:artifactItem[pom:classifier='version']" jetty-home

%pom_xpath_remove 'pom:execution[pom:id="sources"]' jetty-home

sed -i '/^\s*\*.*<script>/d' jetty-util/src/main/java/org/eclipse/jetty/util/resource/Resource.java

%pom_remove_plugin :maven-invoker-plugin jetty-jspc-maven-plugin

%pom_disable_module jetty-osgi

%pom_disable_module jetty-documentation
%pom_remove_dep -r :jetty-documentation
%pom_xpath_remove 'pom:execution[pom:id="unpack-documentation"]' jetty-distribution

%pom_xpath_remove 'pom:artifactItem[pom:artifactId="libsetuid-osx"]' jetty-home/pom.xml

%pom_xpath_remove "pom:execution[pom:id[text()='copy-setuid-deps']]" jetty-home/pom.xml

%pom_disable_module jetty-gcloud
%pom_disable_module test-gcloud-sessions tests/test-sessions
%pom_remove_dep :jetty-gcloud-session-manager jetty-home

%pom_disable_module jetty-memcached
%pom_disable_module test-memcached-sessions tests/test-sessions
%pom_remove_dep :jetty-memcached-sessions jetty-home

%pom_disable_module jetty-hazelcast
%pom_disable_module test-hazelcast-sessions tests/test-sessions
%pom_remove_dep :jetty-hazelcast jetty-home

%pom_disable_module jetty-infinispan
%pom_disable_module test-infinispan-sessions tests/test-sessions
%pom_remove_dep :infinispan-embedded jetty-home
%pom_remove_dep :infinispan-embedded-query jetty-home
%pom_remove_dep :infinispan-remote jetty-home
%pom_remove_dep :infinispan-remote-query jetty-home
%pom_xpath_remove "pom:execution[pom:id='unpack-infinispan-config']" jetty-home

%pom_disable_module jetty-spring

%pom_disable_module jetty-jmh

%pom_disable_module test-distribution tests

%pom_disable_module jetty-alpn-conscrypt-server jetty-alpn
%pom_disable_module jetty-alpn-conscrypt-client jetty-alpn
%pom_remove_dep -r :jetty-alpn-conscrypt-server
%pom_remove_dep -r :jetty-alpn-conscrypt-client
rm -fr examples/embedded/src/main/java/org/eclipse/jetty/embedded/ManyConnectors.java

cp %{SOURCE4} .

sed -i '/<SystemProperty name="jetty.state"/d' \
    jetty-home/src/main/resources/etc/jetty-started.xml

%if %{with jp_minimal}
%pom_remove_plugin :maven-remote-resources-plugin
%pom_remove_plugin :maven-assembly-plugin
%pom_remove_plugin :maven-dependency-plugin jetty-client

%pom_disable_module jetty-ant
%pom_disable_module jetty-http2
%pom_disable_module jetty-fcgi
%pom_disable_module jetty-websocket
%pom_disable_module jetty-servlets
%pom_disable_module apache-jsp
%pom_disable_module apache-jstl
%pom_disable_module jetty-maven-plugin
%pom_disable_module jetty-jspc-maven-plugin
%pom_disable_module jetty-deploy
%pom_disable_module jetty-start
%pom_disable_module jetty-plus
%pom_disable_module jetty-annotations
%pom_disable_module jetty-jndi
%pom_disable_module jetty-cdi
%pom_disable_module jetty-proxy
%pom_disable_module jetty-jaspi
%pom_disable_module jetty-rewrite
%pom_disable_module jetty-nosql
%pom_disable_module jetty-unixsocket
%pom_disable_module tests
%pom_disable_module examples
%pom_disable_module jetty-quickstart
%pom_disable_module jetty-distribution
%pom_disable_module jetty-runner
%pom_disable_module jetty-http-spi
%pom_disable_module jetty-alpn
%pom_disable_module jetty-home
%pom_disable_module jetty-openid

%endif

%build
%mvn_package :jetty-home __noinstall
%mvn_package :jetty-distribution __noinstall
%mvn_package :build-resources __noinstall

%if %{without jp_minimal}
%mvn_package ':*-project' project
%mvn_package ':*-parent' project
%mvn_package ':*-bom' project
%else
%mvn_package ':*-project' __noinstall
%mvn_package ':*-parent' __noinstall
%mvn_package ':*-bom' __noinstall
%endif

%mvn_package :test-mock-resources
%mvn_package ':test-*' __noinstall
%mvn_package ':*-tests' __noinstall
%mvn_package ':*-it' __noinstall
%mvn_package ':example-*' __noinstall
%mvn_package org.eclipse.jetty.tests: __noinstall
%mvn_package ::war: __noinstall
%mvn_package :jetty-runner __noinstall
%mvn_package org.eclipse.jetty.cdi: jetty-cdi
%mvn_package ':jetty-alpn*-client' jetty-alpn-client
%mvn_package ':jetty-alpn*-server' jetty-alpn-server
%mvn_package :apache-jsp jetty-jsp
%mvn_alias :apache-jsp :jetty-jsp

%mvn_build -f -s


%install
%mvn_install

%if %{without jp_minimal}
cp -pr jetty-distribution/target/distribution %{buildroot}%{homedir}
install -dm 755 %{buildroot}%{_bindir}
install -dm 755 %{buildroot}%{_sysconfdir}/logrotate.d
install -dm 755 %{buildroot}%{confdir}
install -dm 755 %{buildroot}%{homedir}/start.d
install -dm 755 %{buildroot}%{logdir}
install -dm 755 %{buildroot}%{rundir}
install -dm 755 %{buildroot}%{tempdir}
install -dm 755 %{buildroot}%{jettylibdir}
install -dm 755 %{buildroot}%{_unitdir}

cp %{SOURCE3} %{buildroot}%{_unitdir}/

install -pm 644 %{SOURCE2} %{buildroot}%{_sysconfdir}/logrotate.d/%{name}
echo '# Placeholder configuration file.  No default is provided.' > \
     %{buildroot}%{confdir}/jetty.conf

build-jar-repository %{buildroot}%{homedir}/lib/apache-jsp \
           tomcat/jasper tomcat/tomcat-juli \
           tomcat/tomcat-jsp-2.3-api tomcat/tomcat-api tomcat/tomcat-util \
           tomcat-taglibs-standard/taglibs-standard-compat \
           tomcat-taglibs-standard/taglibs-standard-impl \
           tomcat/tomcat-util-scan glassfish-el-api glassfish-el

ecj=`echo %{buildroot}%{homedir}/lib/apache-jsp/org.eclipse.jdt.ecj-*.jar`
rm $ecj

xmvn-subst -s -L -R %{buildroot} %{buildroot}%{homedir}/lib

ln -sf %{_javadir}/ecj.jar $ecj

( cat << EO_RC
JAVA_HOME=/usr/lib/jvm/java
JAVA_OPTIONS=
JETTY_HOME=%{homedir}
JETTY_CONSOLE=%{logdir}/jetty-console.log
JETTY_PORT=8080
JETTY_RUN=%{_localstatedir}/run/%{name}
JETTY_PID=\$JETTY_RUN/jetty.pid
EO_RC
) > %{buildroot}%{homedir}/.jettyrc

mkdir -p %{buildroot}%{_tmpfilesdir}
( cat << EOF
D %{rundir} 0755 %username %{username} -
EOF
) > %{buildroot}%{_tmpfilesdir}/%{name}.conf

rm -r %{buildroot}%{homedir}/logs
ln -s %{logdir} %{buildroot}%{homedir}/logs

mv %{buildroot}%{homedir}/etc/* %{buildroot}/%{confdir}/
rm -r %{buildroot}%{homedir}/etc
ln -s %{confdir} %{buildroot}%{homedir}/etc

mv %{buildroot}%{homedir}/webapps %{buildroot}%{appdir}
ln -s %{appdir} %{buildroot}%{homedir}/webapps

rm %{buildroot}%{homedir}/*.txt  %{buildroot}%{homedir}/*.html

ln -sf %{rundir} %{buildroot}%{homedir}/work

cp -p %{SOURCE1} %{buildroot}%{homedir}/bin/jetty.sh


%pre
getent group %username >/dev/null || groupadd -f -g %jtuid -r %username
if ! getent passwd %username >/dev/null ; then
    if ! getent passwd %jtuid >/dev/null ; then
      useradd -r -u %jtuid -g %username -d %homedir -s /sbin/nologin \
      -c "Jetty web server" %username
    else
      useradd -r -g %username -d %homedir -s /sbin/nologin \
      -c "Jetty web server" %username
    fi
fi
exit 0

%post
%systemd_post jetty.service

%preun
%systemd_preun jetty.service

%postun
%systemd_postun_with_restart jetty.service


%endif

%files client -f .mfiles-jetty-client
%files continuation -f .mfiles-jetty-continuation
%files jaas -f .mfiles-jetty-jaas
%files io -f .mfiles-jetty-io
%files server -f .mfiles-jetty-server
%files servlet -f .mfiles-jetty-servlet
%files util -f .mfiles-jetty-util
%license LICENSE NOTICE.txt LICENSE-MIT
%files util-ajax -f .mfiles-jetty-util-ajax
%files webapp -f .mfiles-jetty-webapp
%files jmx -f .mfiles-jetty-jmx
%files xml -f .mfiles-jetty-xml
%files http -f .mfiles-jetty-http
%files security -f .mfiles-jetty-security

%if %{with jp_minimal}
%files
%endif

%if %{without jp_minimal}
%files -f .mfiles
%{_tmpfilesdir}/%{name}.conf
%config(noreplace) %attr(644, root, root) %{_sysconfdir}/logrotate.d/%{name}
%config(noreplace) %{confdir}
%dir %{jettylibdir}
%dir %{jettycachedir}
%{homedir}
%attr(744, jetty, jetty) %{homedir}/bin/jetty.sh
%attr(755, jetty, jetty) %{logdir}
%attr(755, jetty, jetty) %{tempdir}
%ghost %dir %attr(755, jetty, jetty) %{rundir}
%{appdir}
%{_unitdir}/%{name}.service

%files project -f .mfiles-project
%doc README.md VERSION.txt
%license LICENSE NOTICE.txt LICENSE-MIT

%files annotations -f .mfiles-jetty-annotations
%files ant -f .mfiles-jetty-ant
%files cdi -f .mfiles-jetty-cdi
%files deploy -f .mfiles-jetty-deploy
%files fcgi-client -f .mfiles-fcgi-client
%files fcgi-server -f .mfiles-fcgi-server
%files http-spi -f .mfiles-jetty-http-spi
%files jaspi -f .mfiles-jetty-jaspi
%files jndi -f .mfiles-jetty-jndi
%files jsp -f .mfiles-jetty-jsp
%files jstl -f .mfiles-apache-jstl
%files jspc-maven-plugin -f .mfiles-jetty-jspc-maven-plugin
%files maven-plugin -f .mfiles-jetty-maven-plugin
%files plus -f .mfiles-jetty-plus
%files proxy -f .mfiles-jetty-proxy
%files quickstart -f .mfiles-jetty-quickstart
%files rewrite -f .mfiles-jetty-rewrite
%files servlets -f .mfiles-jetty-servlets
%files start -f .mfiles-jetty-start
%files unixsocket -f .mfiles-jetty-unixsocket
%files websocket-api -f .mfiles-websocket-api
%files websocket-client -f .mfiles-websocket-client
%files websocket-common -f .mfiles-websocket-common
%files websocket-server -f .mfiles-websocket-server
%files websocket-servlet -f .mfiles-websocket-servlet
%files javax-websocket-client-impl -f .mfiles-javax-websocket-client-impl
%files javax-websocket-server-impl -f .mfiles-javax-websocket-server-impl
%files alpn-client -f .mfiles-jetty-alpn-client
%files alpn-server -f .mfiles-jetty-alpn-server
%files http2-client -f .mfiles-http2-client
%files http2-common -f .mfiles-http2-common
%files http2-hpack -f .mfiles-http2-hpack
%files http2-http-client-transport -f .mfiles-http2-http-client-transport
%files http2-server -f .mfiles-http2-server
%files nosql -f .mfiles-jetty-nosql
%endif

%files javadoc -f .mfiles-javadoc
%license LICENSE NOTICE.txt LICENSE-MIT

%changelog
* Mon Oct 30 2023 edwardewang <edwardewang@tencent.com> - 9.4.40-4
- Upgrade to 9.4.53 to fix CVE-2023-36479, CVE-2023-41900, CVE-2023-40167

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 9.4.40-3
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 9.4.40-2
- Rebuilt for OpenCloudOS Stream 23.05

* Wed Apr 26 2023 cunshunxia <cunshunxia@tencent.com> - 9.4.40-1
- initial build
